﻿using System;
using ETW.Common;
using System.Threading;
using Microsoft.Diagnostics.Tracing.Session;

namespace ETFListenderDemo
{
    class Program
    {
        
        private static void Main(string[] args)
        {
            if (!(TraceEventSession.IsElevated() ?? false))
            {
                Console.WriteLine("To turn on ETW events you need to be Admin process.");
                Console.ReadKey();
                return;
            }
            Console.WriteLine("press any key to start listening");
            Console.ReadKey();
            var listener = new EtwListener();
            listener.Start();
            bool continueCollection = true;
            while (continueCollection)
            {
                Thread.Sleep(10000);
                Console.WriteLine("Press Q to quit");
                var key = Console.ReadKey();
                if (key.Key == ConsoleKey.Q)
                {
                    continueCollection = false;
                }
            }
           
            listener.Stop();

            CustomEventSource.ReadQueryEvents("CustomSession.etl", 
                queryData => Console.WriteLine("EfExecutionTime: time: {0} for query {1}",
                    queryData.ExecutionTime, queryData.Query));

            Console.WriteLine("press any key to quit");
            Console.ReadKey();


        }
    }
}
