﻿using System;
using Microsoft.Diagnostics.Tracing.Session;

namespace ETW.Common
{
    public class EtwListener : IDisposable
    {

        private const string SessioName = "CustomSession";
        private TraceEventSession _session;
        private bool _stopped;

        public void Start()
        {
            _session = new TraceEventSession(SessioName, "CustomSession.etl");
            _session.EnableProvider("CustomEventSource");
        }

        public void Stop()
        {
            _stopped = true;
            _session.Stop();
            _session.Dispose();

        }

        public void Dispose()
        {
            if (_stopped)
            {
                Dispose();
            }
        }

    }
}
