﻿using System;
using System.Data.Common;
using System.Data.Entity.Infrastructure.Interception;
using ETW.Common;

namespace ETWDemo
{
    public class CustomInterceptor : IDbCommandInterceptor
    {
        public void NonQueryExecuting(
            DbCommand command, DbCommandInterceptionContext<int> interceptionContext)
        {
            interceptionContext.UserState = DateTime.Now;
        }

        public void NonQueryExecuted(
            DbCommand command, DbCommandInterceptionContext<int> interceptionContext)
        {
            CustomEventSource.Logger.EfExecutionTime(
                command.CommandText, DateTime.Now.Subtract((DateTime) interceptionContext.UserState).TotalMilliseconds);
        }

        public void ReaderExecuting(
            DbCommand command, DbCommandInterceptionContext<DbDataReader> interceptionContext)
        {
            interceptionContext.UserState = DateTime.Now;  
        }

        public void ReaderExecuted(
            DbCommand command, DbCommandInterceptionContext<DbDataReader> interceptionContext)
        {
            CustomEventSource.Logger.EfExecutionTime(
                command.CommandText, DateTime.Now.Subtract((DateTime)interceptionContext.UserState).TotalMilliseconds);
        }

        public void ScalarExecuting(
            DbCommand command, DbCommandInterceptionContext<object> interceptionContext)
        {
            interceptionContext.UserState = DateTime.Now;
        }

        public void ScalarExecuted(
            DbCommand command, DbCommandInterceptionContext<object> interceptionContext)
        {
            CustomEventSource.Logger.EfExecutionTime(
                command.CommandText, DateTime.Now.Subtract((DateTime)interceptionContext.UserState).TotalMilliseconds);
        }
    }
}
